Global("texts", { })
Global("L", { })

-- AO game Localization detection by SLA. Version 2011-02-10.
function GetGameLocalization()
 local B = cartographer.GetMapBlocks()
 local T = { rus="\203\232\227\224", 
             eng="Holy Land", 
             ger="Heiliges Land",
             fra="Terre Sacr\233e", 
             br ="Terra Sagrada", 
             jpn="\131\74\131\106\131\65" }
 for b in B do 
   for l,t in T do
     if userMods.FromWString( cartographer.GetMapBlockInfo(B [b] ).name ) == t then
       return l 
     end
   end
 end
 return "eng"
end

function GetTextLocalized(strTextName, language)
  local textgroup = common.GetAddonRelatedTextGroup(language)
  if textgroup then
    return textgroup:GetText(strTextName)
  end
  return common.GetEmptyWString()
end

-- Load all localized texts
-- Load texts for language eng
texts["eng"] = { }
texts["eng"]["settings"] = GetTextLocalized("settings", "eng")
texts["eng"]["close"] = GetTextLocalized("close", "eng")
texts["eng"]["save"] = GetTextLocalized("save", "eng")
texts["eng"]["name"] = GetTextLocalized("name", "eng")
texts["eng"]["hide"] = GetTextLocalized("hide", "eng")
texts["eng"]["show"] = GetTextLocalized("show", "eng")
texts["eng"]["while"] = GetTextLocalized("while", "eng")
texts["eng"]["buff"] = GetTextLocalized("buff", "eng")
texts["eng"]["debuff"] = GetTextLocalized("debuff", "eng")
texts["eng"]["withExactName"] = GetTextLocalized("withExactName", "eng")
texts["eng"]["on"] = GetTextLocalized("on", "eng")
texts["eng"]["you"] = GetTextLocalized("you", "eng")
texts["eng"]["yourtarget"] = GetTextLocalized("yourtarget", "eng")
texts["eng"]["position"] = GetTextLocalized("position", "eng")
texts["eng"]["x"] = GetTextLocalized("x", "eng")
texts["eng"]["y"] = GetTextLocalized("y", "eng")
texts["eng"]["size"] = GetTextLocalized("size", "eng")
texts["eng"]["width"] = GetTextLocalized("width", "eng")
texts["eng"]["height"] = GetTextLocalized("height", "eng")
texts["eng"]["powerAuras"] = GetTextLocalized("powerAuras", "eng")
texts["eng"]["delete"] = GetTextLocalized("delete", "eng")
texts["eng"]["edit"] = GetTextLocalized("edit", "eng")
texts["eng"]["new"] = GetTextLocalized("new", "eng")
texts["eng"]["pauras"] = GetTextLocalized("pauras", "eng")
texts["eng"]["increaseSymbol"] = GetTextLocalized("increaseSymbol", "eng")
texts["eng"]["decreaseSymbol"] = GetTextLocalized("decreaseSymbol", "eng")
texts["eng"]["opacity"] = GetTextLocalized("opacity", "eng")
texts["eng"]["searchwindow"] = GetTextLocalized("searchwindow", "eng")
texts["eng"]["search"] = GetTextLocalized("search", "eng")
texts["eng"]["useBuffImage"] = GetTextLocalized("useBuffImage", "eng")
texts["eng"]["moreconditions"] = GetTextLocalized("moreconditions", "eng")
texts["eng"]["castedbyme"] = GetTextLocalized("castedbyme", "eng")
texts["eng"]["targetoftarget"] = GetTextLocalized("targetoftarget", "eng")
texts["eng"]["pet"] = GetTextLocalized("pet", "eng")
texts["eng"]["notinfight"] = GetTextLocalized("notinfight", "eng")
texts["eng"]["infight"] = GetTextLocalized("infight", "eng")
texts["eng"]["solo"] = GetTextLocalized("solo", "eng")
texts["eng"]["ingroup"] = GetTextLocalized("ingroup", "eng")
texts["eng"]["inraid"] = GetTextLocalized("inraid", "eng")
texts["eng"]["mounted"] = GetTextLocalized("mounted", "eng")
texts["eng"]["notmounted"] = GetTextLocalized("notmounted", "eng")
texts["eng"]["hostile"] = GetTextLocalized("hostile", "eng")
texts["eng"]["friendly"] = GetTextLocalized("friendly", "eng")
texts["eng"]["ifothervisible"] = GetTextLocalized("ifothervisible", "eng")
texts["eng"]["stacksize"] = GetTextLocalized("stacksize", "eng")
texts["eng"]["stackmin"] = GetTextLocalized("stackmin", "eng")
texts["eng"]["stackmax"] = GetTextLocalized("stackmax", "eng")
texts["eng"]["showTimer"] = GetTextLocalized("showTimer", "eng")
texts["eng"]["showImage"] = GetTextLocalized("showImage", "eng")
texts["eng"]["spellcd"] = GetTextLocalized("spellcd", "eng")
-- Load texts for language ger
texts["ger"] = { }
texts["ger"]["settings"] = GetTextLocalized("settings", "ger")
texts["ger"]["close"] = GetTextLocalized("close", "ger")
texts["ger"]["save"] = GetTextLocalized("save", "ger")
texts["ger"]["name"] = GetTextLocalized("name", "ger")
texts["ger"]["hide"] = GetTextLocalized("hide", "ger")
texts["ger"]["show"] = GetTextLocalized("show", "ger")
texts["ger"]["while"] = GetTextLocalized("while", "ger")
texts["ger"]["buff"] = GetTextLocalized("buff", "ger")
texts["ger"]["debuff"] = GetTextLocalized("debuff", "ger")
texts["ger"]["withExactName"] = GetTextLocalized("withExactName", "ger")
texts["ger"]["on"] = GetTextLocalized("on", "ger")
texts["ger"]["you"] = GetTextLocalized("you", "ger")
texts["ger"]["yourtarget"] = GetTextLocalized("yourtarget", "ger")
texts["ger"]["position"] = GetTextLocalized("position", "ger")
texts["ger"]["x"] = GetTextLocalized("x", "ger")
texts["ger"]["y"] = GetTextLocalized("y", "ger")
texts["ger"]["size"] = GetTextLocalized("size", "ger")
texts["ger"]["width"] = GetTextLocalized("width", "ger")
texts["ger"]["height"] = GetTextLocalized("height", "ger")
texts["ger"]["powerAuras"] = GetTextLocalized("powerAuras", "ger")
texts["ger"]["delete"] = GetTextLocalized("delete", "ger")
texts["ger"]["edit"] = GetTextLocalized("edit", "ger")
texts["ger"]["new"] = GetTextLocalized("new", "ger")
texts["ger"]["pauras"] = GetTextLocalized("pauras", "ger")
texts["ger"]["increaseSymbol"] = GetTextLocalized("increaseSymbol", "ger")
texts["ger"]["decreaseSymbol"] = GetTextLocalized("decreaseSymbol", "ger")
texts["ger"]["opacity"] = GetTextLocalized("opacity", "ger")
texts["ger"]["searchwindow"] = GetTextLocalized("searchwindow", "ger")
texts["ger"]["search"] = GetTextLocalized("search", "ger")
texts["ger"]["useBuffImage"] = GetTextLocalized("useBuffImage", "ger")
texts["ger"]["moreconditions"] = GetTextLocalized("moreconditions", "ger")
texts["ger"]["castedbyme"] = GetTextLocalized("castedbyme", "ger")
texts["ger"]["targetoftarget"] = GetTextLocalized("targetoftarget", "ger")
texts["ger"]["pet"] = GetTextLocalized("pet", "ger")
texts["ger"]["notinfight"] = GetTextLocalized("notinfight", "ger")
texts["ger"]["infight"] = GetTextLocalized("infight", "ger")
texts["ger"]["solo"] = GetTextLocalized("solo", "ger")
texts["ger"]["ingroup"] = GetTextLocalized("ingroup", "ger")
texts["ger"]["inraid"] = GetTextLocalized("inraid", "ger")
texts["ger"]["mounted"] = GetTextLocalized("mounted", "ger")
texts["ger"]["notmounted"] = GetTextLocalized("notmounted", "ger")
texts["ger"]["hostile"] = GetTextLocalized("hostile", "ger")
texts["ger"]["friendly"] = GetTextLocalized("friendly", "ger")
texts["ger"]["ifothervisible"] = GetTextLocalized("ifothervisible", "ger")
texts["ger"]["stacksize"] = GetTextLocalized("stacksize", "ger")
texts["ger"]["stackmin"] = GetTextLocalized("stackmin", "ger")
texts["ger"]["stackmax"] = GetTextLocalized("stackmax", "ger")
texts["ger"]["showTimer"] = GetTextLocalized("showTimer", "ger")
texts["ger"]["showImage"] = GetTextLocalized("showImage", "ger")
texts["ger"]["spellcd"] = GetTextLocalized("spellcd", "ger")
-- Load texts for language rus
texts["rus"] = { }
texts["rus"]["settings"] = GetTextLocalized("settings", "rus")
texts["rus"]["close"] = GetTextLocalized("close", "rus")
texts["rus"]["save"] = GetTextLocalized("save", "rus")
texts["rus"]["name"] = GetTextLocalized("name", "rus")
texts["rus"]["hide"] = GetTextLocalized("hide", "rus")
texts["rus"]["show"] = GetTextLocalized("show", "rus")
texts["rus"]["while"] = GetTextLocalized("while", "rus")
texts["rus"]["buff"] = GetTextLocalized("buff", "rus")
texts["rus"]["debuff"] = GetTextLocalized("debuff", "rus")
texts["rus"]["withExactName"] = GetTextLocalized("withExactName", "rus")
texts["rus"]["on"] = GetTextLocalized("on", "rus")
texts["rus"]["you"] = GetTextLocalized("you", "rus")
texts["rus"]["yourtarget"] = GetTextLocalized("yourtarget", "rus")
texts["rus"]["position"] = GetTextLocalized("position", "rus")
texts["rus"]["x"] = GetTextLocalized("x", "rus")
texts["rus"]["y"] = GetTextLocalized("y", "rus")
texts["rus"]["size"] = GetTextLocalized("size", "rus")
texts["rus"]["width"] = GetTextLocalized("width", "rus")
texts["rus"]["height"] = GetTextLocalized("height", "rus")
texts["rus"]["powerAuras"] = GetTextLocalized("powerAuras", "rus")
texts["rus"]["delete"] = GetTextLocalized("delete", "rus")
texts["rus"]["edit"] = GetTextLocalized("edit", "rus")
texts["rus"]["new"] = GetTextLocalized("new", "rus")
texts["rus"]["pauras"] = GetTextLocalized("pauras", "rus")
texts["rus"]["increaseSymbol"] = GetTextLocalized("increaseSymbol", "rus")
texts["rus"]["decreaseSymbol"] = GetTextLocalized("decreaseSymbol", "rus")
texts["rus"]["opacity"] = GetTextLocalized("opacity", "rus")
texts["rus"]["searchwindow"] = GetTextLocalized("searchwindow", "rus")
texts["rus"]["search"] = GetTextLocalized("search", "rus")
texts["rus"]["useBuffImage"] = GetTextLocalized("useBuffImage", "rus")
texts["rus"]["moreconditions"] = GetTextLocalized("moreconditions", "rus")
texts["rus"]["castedbyme"] = GetTextLocalized("castedbyme", "rus")
texts["rus"]["targetoftarget"] = GetTextLocalized("targetoftarget", "rus")
texts["rus"]["pet"] = GetTextLocalized("pet", "rus")
texts["rus"]["notinfight"] = GetTextLocalized("notinfight", "rus")
texts["rus"]["infight"] = GetTextLocalized("infight", "rus")
texts["rus"]["solo"] = GetTextLocalized("solo", "rus")
texts["rus"]["ingroup"] = GetTextLocalized("ingroup", "rus")
texts["rus"]["inraid"] = GetTextLocalized("inraid", "rus")
texts["rus"]["mounted"] = GetTextLocalized("mounted", "rus")
texts["rus"]["notmounted"] = GetTextLocalized("notmounted", "rus")
texts["rus"]["hostile"] = GetTextLocalized("hostile", "rus")
texts["rus"]["friendly"] = GetTextLocalized("friendly", "rus")
texts["rus"]["ifothervisible"] = GetTextLocalized("ifothervisible", "rus")
texts["rus"]["stacksize"] = GetTextLocalized("stacksize", "rus")
texts["rus"]["stackmin"] = GetTextLocalized("stackmin", "rus")
texts["rus"]["stackmax"] = GetTextLocalized("stackmax", "rus")
texts["rus"]["showTimer"] = GetTextLocalized("showTimer", "rus")
texts["rus"]["showImage"] = GetTextLocalized("showImage", "rus")
texts["rus"]["spellcd"] = GetTextLocalized("spellcd", "rus")

-- Initial all registered textelements
function UpdateLocalization()
  View.SearchWindow.textWidget:SetVal("label", L["searchwindow"])
  View.SearchWindow.Grid.searchLabel_text.widget:SetVal("text", L["search"])
  View.SearchWindow.Grid.SearchButton.widget:SetVal("button_label", L["search"])
  View.openConfig.widget:SetVal("button_label", L["pauras"])
  View.Settings.textWidget:SetVal("label", L["settings"])
  View.Settings.DockPanel.BottomButtons.Close.widget:SetVal("button_label", L["close"])
  View.Settings.DockPanel.BottomButtons.Save.widget:SetVal("button_label", L["save"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.widget:SetVal("text", L["name"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.widget:SetVal("text", L["hide"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.widget:SetVal("text", L["show"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.widget:SetVal("text", L["while"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.widget:SetVal("text", L["buff"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.widget:SetVal("text", L["debuff"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.widget:SetVal("text", L["spellcd"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.widget:SetVal("text", L["withExactName"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.widget:SetVal("text", L["on"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.widget:SetVal("text", L["yourtarget"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.widget:SetVal("text", L["you"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.widget:SetVal("text", L["targetoftarget"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.widget:SetVal("text", L["pet"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.widget:SetVal("text", L["moreconditions"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.widget:SetVal("text", L["castedbyme"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.widget:SetVal("text", L["notinfight"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.widget:SetVal("text", L["infight"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.widget:SetVal("text", L["solo"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.widget:SetVal("text", L["ingroup"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.widget:SetVal("text", L["inraid"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.widget:SetVal("text", L["notmounted"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.widget:SetVal("text", L["mounted"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.widget:SetVal("text", L["hostile"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.widget:SetVal("text", L["friendly"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.widget:SetVal("text", L["ifothervisible"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.widget:SetVal("text", L["stacksize"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.widget:SetVal("text", L["stackmin"])
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.widget:SetVal("text", L["stackmax"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.widget:SetVal("text", L["useBuffImage"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.widget:SetVal("text", L["showTimer"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.widget:SetVal("text", L["showImage"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.widget:SetVal("text", L["position"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.widget:SetVal("text", L["x"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.widget:SetVal("text", L["y"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.widget:SetVal("text", L["size"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.widget:SetVal("text", L["width"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.widget:SetVal("text", L["height"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.widget:SetVal("text", L["opacity"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.widget:SetVal("button_label", L["decreaseSymbol"])
  View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.widget:SetVal("button_label", L["increaseSymbol"])
  View.AurasWindow.textWidget:SetVal("label", L["powerAuras"])
  View.AurasWindow.AuraLine.Delete.widget:SetVal("button_label", L["delete"])
  View.AurasWindow.AuraLine.Edit.widget:SetVal("button_label", L["edit"])
  View.AurasWindow.DockPanel.ButtomButtons.Add.widget:SetVal("button_label", L["new"])
end
-- Set L to English, because in AO 2.0.03 was the GetGameLocalization broken
-- and L was nil. I used the second timer and every second occur an error.
L = texts["eng"]