--------------------------------------------------------------------------------
--- Globals
--------------------------------------------------------------------------------
Global("knownBuffs", { })
--------------------------------------------------------------------------------
--- REACTIONS
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
--- Functions
--------------------------------------------------------------------------------
function IsWStringInTable(table, wstring)
  for k, v in table do
	if common.CompareWString(k, wstring) == 0 then
	  return true
	end
  end
  return false
end

function UpdateValueByWString(table, wstring, value)
  for k, v in table do
	if common.CompareWString(k, wstring) == 0 then
	  table[k] = value
	  return
	end
  end
  table[wstring] = value
end

function SearchImageByBuffName(name)
  for k, v in knownBuffs do
    if common.CompareWString(k, name) == 0 then
	  return v
	end
  end
  return nil
end

function UpdateKnownBuffs(unitId) 
  for k, buff in GetBuffData(unitId) do
    if not IsWStringInTable(knownBuffs, buff.name) then
      knownBuffs[buff.name] = buff
    end
  end
end

--------------------------------------------------------------------------------
--- Unit Buff Data
--------------------------------------------------------------------------------
Global("unitBuffData", { })

function ClearBuffData()
  for k, v in unitBuffData do
    unitBuffData[k] = nil
  end
end

function GetBuffData(unitId)
  if not unitBuffData[unitId] then
    local buffs = { }
	local count = unit. GetBuffCount(unitId)  
    for i=1, count do
      table.insert(buffs, unit.GetBuff(unitId, i-1))
	end
	unitBuffData[unitId] = buffs
	return buffs
  end
  return unitBuffData[unitId]
end
--------------------------------------------------------------------------------
--- INITIALIZATION
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
