Global("View", { })

View.widget = mainForm

View.TimerTemplate = { }
View.TimerTemplate.widget = View.widget:GetChildChecked("TimerTemplate", false)
View.TimerTemplate.Values = { }
View.TimerTemplate.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.TimerTemplate.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.TimerTemplate.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.TimerTemplate.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.TimerTemplate.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.TimerTemplate.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.TimerTemplate.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.TimerTemplate.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SearchWindow = { }
View.SearchWindow.widget = View.widget:GetChildChecked("SearchWindow", false)
View.SearchWindow.DNDID = 90
View.SearchWindow.isVisible = true
View.SearchWindow.initDnD = function(self, wtReacting, fUseCfg, fLockedToScreenArea, Padding )
  if not wtReacting then
    wtReacting = self.widget
  end
  if not true then -- is DragAndDrop disabled?
    LogWarning("On the Window SearchWindow was called the initDnD-Function, but DnD is disabled.")
  else
    DnD:Init(self.DNDID, wtReacting, self.widget, fUseCfg, fLockedToScreenArea, Padding)
  end
end
View.SearchWindow.show = function(self, visible)
  if(self.isVisible~=visible) then
    self.isVisible=visible
    if not true then -- is DragAndDrop disabled?
      if not visible then
        DnD:Unreg(self)
      else
        DnD:Reg(self)
      end
    end
  end
  self.widget:Show(visible)
end
View.SearchWindow.showCloseButton = function(self, visible)
  self.closeButtonWidget:Show(visible)
  self.goldenCornerWidget:Show(visible)
end
View.SearchWindow.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SearchWindow.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SearchWindow.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SearchWindow.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SearchWindow.titleWidget = View.SearchWindow.widget:GetChildChecked("Header", false)
View.SearchWindow.textWidget = View.SearchWindow.titleWidget:GetChildChecked("Headertext", false)
View.SearchWindow.backgroundWidget = View.SearchWindow.widget:GetChildChecked("Background", false)
View.SearchWindow.closeButtonWidget = View.SearchWindow.widget:GetChildChecked("Close", false)
View.SearchWindow.goldenCornerWidget = View.SearchWindow.widget:GetChildChecked("GoldenCorner", false)
View.SearchWindow.contentWidget = View.SearchWindow.widget:GetChildChecked("Content", false)
View.SearchWindow.text = ""
View.SearchWindow.setTitleText = function(self, text)
  self.text=text
  self.textWidget:SetVal("label", text)
end
View.SearchWindow.getTitleText = function(self)
  return self.text
end
View.SearchWindow.getBackgroundFade = function(self)
  return self.backgroundWidget:GetFade()
end
View.SearchWindow.setBackgroundFade = function(self, fade)
  return self.backgroundWidget:SetFade(fade)
end
View.SearchWindow.getContentFade = function(self)
  return self.contentWidget:GetFade()
end
View.SearchWindow.setContentFade = function(self, fade)
  return self.contentWidget:SetFade(fade)
end

View.SearchWindow.Grid = { }
View.SearchWindow.Grid.widget = View.SearchWindow.widget:GetChildChecked("Content", false):GetChildChecked("Grid", false)

View.SearchWindow.Grid.searchLabel_text = { }
View.SearchWindow.Grid.searchLabel_text.widget = View.SearchWindow.Grid.widget:GetChildChecked("searchLabel_text", false)
View.SearchWindow.Grid.searchLabel_text.Values = { }
View.SearchWindow.Grid.searchLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.searchLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SearchWindow.Grid.searchLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.searchLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SearchWindow.Grid.searchLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.searchLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SearchWindow.Grid.searchLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.searchLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SearchWindow.Grid.searchLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.SearchWindow.Grid.searchLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.SearchWindow.Grid.searchLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.SearchWindow.Grid.searchLabel_text:setMargin(4, 4, 0, 0)
View.SearchWindow.Grid.searchLabel_text:setSize(100, 25)
View.SearchWindow.Grid.searchLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.SearchWindow.Grid.SearchName = { }
View.SearchWindow.Grid.SearchName.widget = View.SearchWindow.Grid.widget:GetChildChecked("SearchName", false)
View.SearchWindow.Grid.SearchName.reactionChanged = ""
View.SearchWindow.Grid.SearchName.reactionEnter = "searchNameEnter"
View.SearchWindow.Grid.SearchName.reactionESC = "searchNameESC"
View.SearchWindow.Grid.SearchName.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.SearchName.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SearchWindow.Grid.SearchName.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.SearchName.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SearchWindow.Grid.SearchName.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.SearchName.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SearchWindow.Grid.SearchName.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.SearchName.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SearchWindow.Grid.SearchName.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.SearchWindow.Grid.SearchName.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.SearchWindow.Grid.SearchName.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.SearchWindow.Grid.SearchName.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.SearchWindow.Grid.SearchName.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.SearchWindow.Grid.SearchName.getText = function(self)
  return self.widget:GetText()
end
View.SearchWindow.Grid.SearchName.setText = function(self, text)
  self.widget:SetText(text)
end
View.SearchWindow.Grid.SearchName.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.SearchWindow.Grid.SearchName.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "searchNameESC")
View.SearchWindow.Grid.SearchName:setMargin(100, 0, 0, 0)
View.SearchWindow.Grid.SearchName:setSize(450, 25)
View.SearchWindow.Grid.SearchName:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.SearchWindow.Grid.SearchButton = { }
View.SearchWindow.Grid.SearchButton.widget = View.SearchWindow.Grid.widget:GetChildChecked("SearchButton", false)
View.SearchWindow.Grid.SearchButton.Values = { }
View.SearchWindow.Grid.SearchButton.reactionName = "searchButtonClicked"
View.SearchWindow.Grid.SearchButton.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.SearchButton.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SearchWindow.Grid.SearchButton.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.SearchButton.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SearchWindow.Grid.SearchButton.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.SearchButton.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SearchWindow.Grid.SearchButton.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SearchWindow.Grid.SearchButton.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SearchWindow.Grid.SearchButton.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.SearchWindow.Grid.SearchButton.getVal = function(self, tag)
  return self.Values[tag]
end
View.SearchWindow.Grid.SearchButton:setMargin(550, 0, 0, 0)
View.SearchWindow.Grid.SearchButton:setSize(75, 25)
View.SearchWindow.Grid.SearchButton:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.SearchWindow.Grid.SearchResult = { }
View.SearchWindow.Grid.SearchResult.widget = View.SearchWindow.Grid.widget:GetChildChecked("SearchResult", false)
for k, v in View.SearchWindow.Grid.SearchResult do
  if v then
    if v.widget then
      View.SearchWindow.Grid.SearchResult.widget:PushBack(v.widget)
    end
  end
end
View.SearchResultTemplate = { }
View.SearchResultTemplate.widget = View.widget:GetChildChecked("SearchResultTemplate", false)

View.SearchResultTemplate.Image = { }
View.SearchResultTemplate.Image.widget = View.SearchResultTemplate.widget:GetChildChecked("Image", false)
View.SearchResultTemplate.Image.Values = { }
View.SearchResultTemplate.Image.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SearchResultTemplate.Image.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SearchResultTemplate.Image.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SearchResultTemplate.Image.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SearchResultTemplate.Image.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SearchResultTemplate.Image.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SearchResultTemplate.Image.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SearchResultTemplate.Image.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SearchResultTemplate.Button = { }
View.SearchResultTemplate.Button.widget = View.SearchResultTemplate.widget:GetChildChecked("Button", false)
View.SearchResultTemplate.Button.Values = { }
View.SearchResultTemplate.Button.reactionName = "searchResultItemClicked"
View.SearchResultTemplate.Button.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SearchResultTemplate.Button.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SearchResultTemplate.Button.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SearchResultTemplate.Button.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SearchResultTemplate.Button.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SearchResultTemplate.Button.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SearchResultTemplate.Button.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SearchResultTemplate.Button.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SearchResultTemplate.Button.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.SearchResultTemplate.Button.getVal = function(self, tag)
  return self.Values[tag]
end
View.SearchResultTemplate.Button:setMargin(35, 0, 0, 0)
View.SearchResultTemplate.Button:setSize(590, 35)
View.SearchResultTemplate.Button:setAlignment(WIDGET_ALIGN_BOTH, WIDGET_ALIGN_BOTH)
View.AuraPanel = { }
View.AuraPanel.widget = View.widget:GetChildChecked("AuraPanel", false)
View.AuraPanel.Values = { }
View.AuraPanel.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.AuraPanel.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.AuraPanel.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.AuraPanel.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.AuraPanel.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.AuraPanel.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.AuraPanel.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.AuraPanel.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.openConfig = { }
View.openConfig.widget = View.widget:GetChildChecked("openConfig", false)
View.openConfig.Values = { }
View.openConfig.reactionName = "openConfig"
View.openConfig.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.openConfig.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.openConfig.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.openConfig.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.openConfig.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.openConfig.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.openConfig.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.openConfig.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.openConfig.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.openConfig.getVal = function(self, tag)
  return self.Values[tag]
end
View.openConfig:setMargin(400, 0, 0, 0)
View.openConfig:setSize(65, 25)
View.openConfig:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.SettingsPreview = { }
View.SettingsPreview.widget = View.widget:GetChildChecked("SettingsPreview", false)
View.SettingsPreview.Values = { }
View.SettingsPreview.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SettingsPreview.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SettingsPreview.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SettingsPreview.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SettingsPreview.Cooldown = { }
View.SettingsPreview.Cooldown.widget = View.SettingsPreview.widget:GetChildChecked("Cooldown", false)
View.SettingsPreview.Cooldown.Values = { }
View.SettingsPreview.Cooldown.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Cooldown.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SettingsPreview.Cooldown.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Cooldown.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SettingsPreview.Cooldown.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Cooldown.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SettingsPreview.Cooldown.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Cooldown.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SettingsPreview.Cooldown.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.SettingsPreview.Cooldown.getVal = function(self, tag)
  return self.Values[tag]
end
View.SettingsPreview.Cooldown.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.SettingsPreview.Cooldown:setMargin(-30, 0, -50, 0)
View.SettingsPreview.Cooldown:setSize(130, 20)
View.SettingsPreview.Cooldown:setAlignment(WIDGET_ALIGN_BOTH, WIDGET_ALIGN_LOW)
View.SettingsPreview.Stacksize = { }
View.SettingsPreview.Stacksize.widget = View.SettingsPreview.widget:GetChildChecked("Stacksize", false)
View.SettingsPreview.Stacksize.Values = { }
View.SettingsPreview.Stacksize.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Stacksize.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SettingsPreview.Stacksize.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Stacksize.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SettingsPreview.Stacksize.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Stacksize.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SettingsPreview.Stacksize.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Stacksize.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.SettingsPreview.Stacksize.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.SettingsPreview.Stacksize.getVal = function(self, tag)
  return self.Values[tag]
end
View.SettingsPreview.Stacksize.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.SettingsPreview.Stacksize:setMargin(0, 0, 10, 10)
View.SettingsPreview.Stacksize:setSize(120, 40)
View.SettingsPreview.Stacksize:setAlignment(WIDGET_ALIGN_BOTH, WIDGET_ALIGN_HIGH)
View.SettingsPreview.Image = { }
View.SettingsPreview.Image.widget = View.SettingsPreview.widget:GetChildChecked("Image", false)
View.SettingsPreview.Image.Values = { }
View.SettingsPreview.Image.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Image.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.SettingsPreview.Image.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Image.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.SettingsPreview.Image.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Image.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.SettingsPreview.Image.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.SettingsPreview.Image.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings = { }
View.Settings.widget = View.widget:GetChildChecked("Settings", false)
View.Settings.DNDID = 91
View.Settings.isVisible = true
View.Settings.initDnD = function(self, wtReacting, fUseCfg, fLockedToScreenArea, Padding )
  if not wtReacting then
    wtReacting = self.widget
  end
  if not true then -- is DragAndDrop disabled?
    LogWarning("On the Window Settings was called the initDnD-Function, but DnD is disabled.")
  else
    DnD:Init(self.DNDID, wtReacting, self.widget, fUseCfg, fLockedToScreenArea, Padding)
  end
end
View.Settings.show = function(self, visible)
  if(self.isVisible~=visible) then
    self.isVisible=visible
    if not true then -- is DragAndDrop disabled?
      if not visible then
        DnD:Unreg(self)
      else
        DnD:Reg(self)
      end
    end
  end
  self.widget:Show(visible)
end
View.Settings.showCloseButton = function(self, visible)
  self.closeButtonWidget:Show(visible)
  self.goldenCornerWidget:Show(visible)
end
View.Settings.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.titleWidget = View.Settings.widget:GetChildChecked("Header", false)
View.Settings.textWidget = View.Settings.titleWidget:GetChildChecked("Headertext", false)
View.Settings.backgroundWidget = View.Settings.widget:GetChildChecked("Background", false)
View.Settings.closeButtonWidget = View.Settings.widget:GetChildChecked("Close", false)
View.Settings.goldenCornerWidget = View.Settings.widget:GetChildChecked("GoldenCorner", false)
View.Settings.contentWidget = View.Settings.widget:GetChildChecked("Content", false)
View.Settings.text = ""
View.Settings.setTitleText = function(self, text)
  self.text=text
  self.textWidget:SetVal("label", text)
end
View.Settings.getTitleText = function(self)
  return self.text
end
View.Settings.getBackgroundFade = function(self)
  return self.backgroundWidget:GetFade()
end
View.Settings.setBackgroundFade = function(self, fade)
  return self.backgroundWidget:SetFade(fade)
end
View.Settings.getContentFade = function(self)
  return self.contentWidget:GetFade()
end
View.Settings.setContentFade = function(self, fade)
  return self.contentWidget:SetFade(fade)
end

View.Settings.DockPanel = { }
View.Settings.DockPanel.widget = View.Settings.widget:GetChildChecked("Content", false):GetChildChecked("DockPanel", false)

View.Settings.DockPanel.BottomButtons = { }
View.Settings.DockPanel.BottomButtons.widget = View.Settings.DockPanel.widget:GetChildChecked("BottomButtons", false)

View.Settings.DockPanel.BottomButtons.Close = { }
View.Settings.DockPanel.BottomButtons.Close.widget = View.Settings.DockPanel.BottomButtons.widget:GetChildChecked("Close", false)
View.Settings.DockPanel.BottomButtons.Close.Values = { }
View.Settings.DockPanel.BottomButtons.Close.reactionName = "close"
View.Settings.DockPanel.BottomButtons.Close.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.BottomButtons.Close.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.BottomButtons.Close.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.BottomButtons.Close.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.BottomButtons.Close.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.BottomButtons.Close.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.BottomButtons.Close.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.BottomButtons.Close.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.BottomButtons.Close.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.BottomButtons.Close.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.BottomButtons.Close:setMargin(0, 0, 0, 0)
View.Settings.DockPanel.BottomButtons.Close:setSize(200, 25)
View.Settings.DockPanel.BottomButtons.Close:setAlignment(WIDGET_ALIGN_HIGH, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.BottomButtons.Save = { }
View.Settings.DockPanel.BottomButtons.Save.widget = View.Settings.DockPanel.BottomButtons.widget:GetChildChecked("Save", false)
View.Settings.DockPanel.BottomButtons.Save.Values = { }
View.Settings.DockPanel.BottomButtons.Save.reactionName = "save"
View.Settings.DockPanel.BottomButtons.Save.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.BottomButtons.Save.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.BottomButtons.Save.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.BottomButtons.Save.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.BottomButtons.Save.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.BottomButtons.Save.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.BottomButtons.Save.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.BottomButtons.Save.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.BottomButtons.Save.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.BottomButtons.Save.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.BottomButtons.Save:setMargin(0, 0, 200, 0)
View.Settings.DockPanel.BottomButtons.Save:setSize(200, 25)
View.Settings.DockPanel.BottomButtons.Save:setAlignment(WIDGET_ALIGN_HIGH, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid = { }
View.Settings.DockPanel.ConfigGrid.widget = View.Settings.DockPanel.widget:GetChildChecked("ConfigGrid", false)

View.Settings.DockPanel.ConfigGrid.PictureView = { }
View.Settings.DockPanel.ConfigGrid.PictureView.widget = View.Settings.DockPanel.ConfigGrid.widget:GetChildChecked("PictureView", false)
View.Settings.DockPanel.ConfigGrid.PictureView.Values = { }
View.Settings.DockPanel.ConfigGrid.PictureView.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PictureView.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PictureView.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PictureView.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PictureView.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PictureView.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PictureView.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PictureView.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.Prev = { }
View.Settings.DockPanel.ConfigGrid.Prev.widget = View.Settings.DockPanel.ConfigGrid.widget:GetChildChecked("Prev", false)
View.Settings.DockPanel.ConfigGrid.Prev.Values = { }
View.Settings.DockPanel.ConfigGrid.Prev.reactionName = "prev_image"
View.Settings.DockPanel.ConfigGrid.Prev.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.Prev.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.Prev.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.Prev.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.Prev.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.Prev.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.Prev.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.Prev.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.Prev.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.Prev.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.Prev:setMargin(0, 200, 0, 0)
View.Settings.DockPanel.ConfigGrid.Prev:setSize(100, 25)
View.Settings.DockPanel.ConfigGrid.Prev:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.Next = { }
View.Settings.DockPanel.ConfigGrid.Next.widget = View.Settings.DockPanel.ConfigGrid.widget:GetChildChecked("Next", false)
View.Settings.DockPanel.ConfigGrid.Next.Values = { }
View.Settings.DockPanel.ConfigGrid.Next.reactionName = "next_image"
View.Settings.DockPanel.ConfigGrid.Next.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.Next.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.Next.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.Next.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.Next.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.Next.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.Next.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.Next.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.Next.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.Next.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.Next:setMargin(100, 200, 0, 0)
View.Settings.DockPanel.ConfigGrid.Next:setSize(100, 25)
View.Settings.DockPanel.ConfigGrid.Next:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget = View.Settings.DockPanel.ConfigGrid.widget:GetChildChecked("ConditionGrid", false)

View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("itemNameLabel_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text:setMargin(4, 4, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text:setSize(160, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemNameLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("itemName", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.reactionChanged = ""
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.reactionEnter = ""
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.reactionESC = "itemNameESC"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "itemNameESC")
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName:setMargin(170, 0, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName:setSize(140, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.itemName:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("hide", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.Name = "hide"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide:setChecked(false)
onReaction["hide_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("hide_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text:setMargin(4, 35, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text:setSize(160, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.hide_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("show", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.Name = "show"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show:setChecked(false)
onReaction["show_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.show.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("show_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text:setMargin(174, 35, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text:setSize(140, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.show_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("while_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text:setMargin(314, 35, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text:setSize(125, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.while_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("buff", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.Name = "buff"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff:setChecked(false)
onReaction["buff_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("buff_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text:setMargin(4, 70, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text:setSize(160, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.buff_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("debuff", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.Name = "debuff"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff:setChecked(false)
onReaction["debuff_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("debuff_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text:setMargin(174, 70, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text:setSize(140, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.debuff_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("spellCD", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.Name = "spellCD"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD:setChecked(false)
onReaction["spellCD_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("spellCD_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text:setMargin(4, 101, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text:setSize(160, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.spellCD_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("withExactName_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text:setMargin(4, 132, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text:setSize(160, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.withExactName_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("name", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.reactionChanged = "nameChanged"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.reactionEnter = "removeFocus"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.reactionESC = "nameESC"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "nameESC")
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name:setMargin(170, 128, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name:setSize(140, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.name:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("nameSearch", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.reactionName = "nameSearchClicked"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch:setMargin(310, 128, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch:setSize(25, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.nameSearch:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("on_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text:setMargin(339, 132, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text:setSize(100, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.on_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("target", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.Name = "target"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target:setChecked(false)
onReaction["target_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.target.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("target_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text:setMargin(4, 163, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text:setSize(160, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.target_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("you", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.Name = "you"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you:setChecked(false)
onReaction["you_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.you.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("you_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text:setMargin(174, 163, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text:setSize(140, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.you_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("targetOfTarget", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.Name = "targetOfTarget"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget:setChecked(false)
onReaction["targetOfTarget_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("targetOfTarget_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text:setMargin(4, 194, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text:setSize(160, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.targetOfTarget_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("pet", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.Name = "pet"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet:setChecked(false)
onReaction["pet_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("pet_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text:setMargin(174, 194, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text:setSize(140, 30)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.pet_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.widget:GetChildChecked("extendedConditions", false)

View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("moreconditions_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text:setMargin(4, 4, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text:setSize(420, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.moreconditions_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("castedByMe", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.Name = "castedByMe"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe:setChecked(false)
onReaction["castedByMe_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("castedByMe_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text:setMargin(29, 30, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text:setSize(335, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.castedByMe_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("notInFight", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.Name = "notInFight"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight:setChecked(false)
onReaction["notInFight_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("notInFight_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text:setMargin(29, 56, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text:setSize(250, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notInFight_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("inFight", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.Name = "inFight"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight:setChecked(false)
onReaction["inFight_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("inFight_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text:setMargin(279, 56, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text:setSize(170, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inFight_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("solo", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.Name = "solo"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo:setChecked(false)
onReaction["solo_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("solo_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text:setMargin(29, 82, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text:setSize(250, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.solo_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("inGroup", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.Name = "inGroup"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup:setChecked(false)
onReaction["inGroup_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("inGroup_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text:setMargin(279, 82, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text:setSize(170, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inGroup_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("inRaid", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.Name = "inRaid"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid:setChecked(false)
onReaction["inRaid_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("inRaid_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text:setMargin(29, 108, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text:setSize(250, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.inRaid_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("notMounted", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.Name = "notMounted"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted:setChecked(false)
onReaction["notMounted_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("notMounted_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text:setMargin(29, 134, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text:setSize(250, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.notMounted_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("mounted", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.Name = "mounted"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted:setChecked(false)
onReaction["mounted_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("mounted_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text:setMargin(279, 134, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text:setSize(170, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.mounted_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("hostile", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.Name = "hostile"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile:setChecked(false)
onReaction["hostile_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("hostile_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text:setMargin(29, 160, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text:setSize(250, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.hostile_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("friendly", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.Name = "friendly"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly:setChecked(false)
onReaction["friendly_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("friendly_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text:setMargin(279, 160, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text:setSize(170, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.friendly_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("ifOtherVisible", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.Name = "ifOtherVisible"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible:setChecked(false)
onReaction["ifOtherVisible_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("ifOtherVisible_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text:setMargin(29, 186, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text:setSize(250, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.ifOtherVisible_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("otherrule", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.reactionChanged = "otherruleChanged"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.reactionEnter = ""
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.reactionESC = "otherruleESC"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "otherruleESC")
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule:setMargin(255, 182, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule:setSize(165, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.otherrule:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("stacksize_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text:setMargin(4, 212, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text:setSize(420, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stacksize_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("stackmin", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.Name = "stackmin"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin:setChecked(false)
onReaction["stackmin_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("stackmin_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text:setMargin(49, 238, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text:setSize(250, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmin_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("stackminedit", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.reactionChanged = "stackmineditChanged"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.reactionEnter = ""
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.reactionESC = "stackmineditESC"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "stackmineditESC")
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit:setMargin(170, 234, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit:setSize(85, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackminedit:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("stackmax", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.Name = "stackmax"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax:setChecked(false)
onReaction["stackmax_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("stackmax_text", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.Values = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text:setMargin(49, 264, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text:setSize(250, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmax_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit = { }
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.widget = View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.widget:GetChildChecked("stackmaxedit", false)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.reactionChanged = "stackmaxeditChanged"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.reactionEnter = ""
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.reactionESC = "stackmaxeditESC"
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "stackmaxeditESC")
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit:setMargin(170, 260, 0, 0)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit:setSize(85, 25)
View.Settings.DockPanel.ConfigGrid.ConditionGrid.extendedConditions.stackmaxedit:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.widget = View.Settings.DockPanel.ConfigGrid.widget:GetChildChecked("PositionGrid", false)

View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("useBuffImageLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text:setMargin(4, 8, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text:setSize(125, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffImageLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("useBuffCheckBox", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.Name = "useBuffCheckBox"
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox:setChecked(false)
onReaction["useBuffCheckBox_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.PositionGrid.useBuffCheckBox.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("showTimerLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text:setMargin(4, 39, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text:setSize(125, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("showTimerCheckBox", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.Name = "showTimerCheckBox"
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox:setChecked(false)
onReaction["showTimerCheckBox_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.PositionGrid.showTimerCheckBox.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("showImageLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text:setMargin(4, 70, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text:setSize(125, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("showImageCheckBox", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.Name = "showImageCheckBox"
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.getChecked = function(self)
  return self.widget:GetVariant() == 1
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.setChecked = function(self, checked)
  local currentVariant = self.widget:GetVariant()
  if checked then
    if currentVariant == 0 then
      self.widget:SetVariant(1)
    end
  else
    if currentVariant == 1 then
      self.widget:SetVariant(0)
    end
  end
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.onClick = function(params)
  local currentVariant = params.widget:GetVariant()
  if currentVariant == 0 then
    params.widget:SetVariant(1)
  else
    params.widget:SetVariant(0)
  end
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox:setChecked(false)
onReaction["showImageCheckBox_clicked"] = function(params)
  View.Settings.DockPanel.ConfigGrid.PositionGrid.showImageCheckBox.onClick(params)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("positionLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text:setMargin(4, 101, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text:setSize(100, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("positionXLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text:setMargin(29, 132, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text:setSize(75, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionXLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("positionX", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.reactionChanged = "positionSizeChanged"
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.reactionEnter = ""
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.reactionESC = "positionXESC"
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "positionXESC")
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX:setMargin(125, 128, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX:setSize(90, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionX:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("positionYLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text:setMargin(29, 163, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text:setSize(75, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionYLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("positionY", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.reactionChanged = "positionSizeChanged"
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.reactionEnter = ""
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.reactionESC = "positionYESC"
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "positionYESC")
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY:setMargin(125, 159, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY:setSize(90, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.positionY:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("sizeLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text:setMargin(4, 208, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text:setSize(100, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("sizeXLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text:setMargin(29, 239, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text:setSize(75, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeXLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("sizeX", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.reactionChanged = "positionSizeChanged"
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.reactionEnter = ""
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.reactionESC = "sizeXESC"
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "sizeXESC")
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX:setMargin(125, 235, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX:setSize(90, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeX:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("sizeYLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text:setMargin(29, 270, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text:setSize(75, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeYLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("sizeY", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.reactionChanged = "positionSizeChanged"
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.reactionEnter = ""
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.reactionESC = "sizeYESC"
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.getTextLength = function(self)
  return self.widget:GetPosObjectCount()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.getCursorPos = function(self)
  return self.widget:GetCursorPos()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setCursorPos = function(self, index)
  self.widget:SetCursorPos(index)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setCursorPosToBegin = function(self)
  self.widget:SetCursorPos(0)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setCursorPosToEnd = function(self)
  self.widget:SetCursorPos(self:getTextLength())
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.getText = function(self)
  return self.widget:GetText()
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setText = function(self, text)
  self.widget:SetText(text)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.setFocus = function(self, focus)
  self.widget:SetFocus(focus)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY.getFocus = function(self)
  return self.widget:IsFocused()
end
common.RegisterReactionHandler(function(params)
  params.widget:SetFocus(false)
end, "sizeYESC")
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY:setMargin(125, 266, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY:setSize(90, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.sizeY:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("opacityLabel_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text:setMargin(4, 315, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text:setSize(125, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacityLabel_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("opacity_text", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text:setMargin(129, 315, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text:setSize(90, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.opacity_text:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("OpacityDecrease", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.reactionName = "decreaseOpacity"
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease:setMargin(165, 311, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease:setSize(25, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityDecrease:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.widget = View.Settings.DockPanel.ConfigGrid.PositionGrid.widget:GetChildChecked("OpacityIncrease", false)
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.Values = { }
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.reactionName = "increaseOpacity"
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease.getVal = function(self, tag)
  return self.Values[tag]
end
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease:setMargin(190, 311, 0, 0)
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease:setSize(25, 30)
View.Settings.DockPanel.ConfigGrid.PositionGrid.OpacityIncrease:setAlignment(WIDGET_ALIGN_LOW, WIDGET_ALIGN_LOW)
View.AurasWindow = { }
View.AurasWindow.widget = View.widget:GetChildChecked("AurasWindow", false)
View.AurasWindow.DNDID = 92
View.AurasWindow.isVisible = true
View.AurasWindow.initDnD = function(self, wtReacting, fUseCfg, fLockedToScreenArea, Padding )
  if not wtReacting then
    wtReacting = self.widget
  end
  if not true then -- is DragAndDrop disabled?
    LogWarning("On the Window AurasWindow was called the initDnD-Function, but DnD is disabled.")
  else
    DnD:Init(self.DNDID, wtReacting, self.widget, fUseCfg, fLockedToScreenArea, Padding)
  end
end
View.AurasWindow.show = function(self, visible)
  if(self.isVisible~=visible) then
    self.isVisible=visible
    if not true then -- is DragAndDrop disabled?
      if not visible then
        DnD:Unreg(self)
      else
        DnD:Reg(self)
      end
    end
  end
  self.widget:Show(visible)
end
View.AurasWindow.showCloseButton = function(self, visible)
  self.closeButtonWidget:Show(visible)
  self.goldenCornerWidget:Show(visible)
end
View.AurasWindow.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.AurasWindow.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.AurasWindow.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.AurasWindow.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.AurasWindow.titleWidget = View.AurasWindow.widget:GetChildChecked("Header", false)
View.AurasWindow.textWidget = View.AurasWindow.titleWidget:GetChildChecked("Headertext", false)
View.AurasWindow.backgroundWidget = View.AurasWindow.widget:GetChildChecked("Background", false)
View.AurasWindow.closeButtonWidget = View.AurasWindow.widget:GetChildChecked("Close", false)
View.AurasWindow.goldenCornerWidget = View.AurasWindow.widget:GetChildChecked("GoldenCorner", false)
View.AurasWindow.contentWidget = View.AurasWindow.widget:GetChildChecked("Content", false)
View.AurasWindow.text = ""
View.AurasWindow.setTitleText = function(self, text)
  self.text=text
  self.textWidget:SetVal("label", text)
end
View.AurasWindow.getTitleText = function(self)
  return self.text
end
View.AurasWindow.getBackgroundFade = function(self)
  return self.backgroundWidget:GetFade()
end
View.AurasWindow.setBackgroundFade = function(self, fade)
  return self.backgroundWidget:SetFade(fade)
end
View.AurasWindow.getContentFade = function(self)
  return self.contentWidget:GetFade()
end
View.AurasWindow.setContentFade = function(self, fade)
  return self.contentWidget:SetFade(fade)
end

View.AurasWindow.AuraLine = { }
View.AurasWindow.AuraLine.widget = View.AurasWindow.widget:GetChildChecked("Content", false):GetChildChecked("AuraLine", false)

View.AurasWindow.AuraLine.PictureView = { }
View.AurasWindow.AuraLine.PictureView.widget = View.AurasWindow.AuraLine.widget:GetChildChecked("PictureView", false)
View.AurasWindow.AuraLine.PictureView.Values = { }
View.AurasWindow.AuraLine.PictureView.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.PictureView.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.AurasWindow.AuraLine.PictureView.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.PictureView.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.AurasWindow.AuraLine.PictureView.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.PictureView.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.AurasWindow.AuraLine.PictureView.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.PictureView.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.AurasWindow.AuraLine.Delete = { }
View.AurasWindow.AuraLine.Delete.widget = View.AurasWindow.AuraLine.widget:GetChildChecked("Delete", false)
View.AurasWindow.AuraLine.Delete.Values = { }
View.AurasWindow.AuraLine.Delete.reactionName = "delete"
View.AurasWindow.AuraLine.Delete.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.Delete.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.AurasWindow.AuraLine.Delete.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.Delete.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.AurasWindow.AuraLine.Delete.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.Delete.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.AurasWindow.AuraLine.Delete.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.Delete.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.AurasWindow.AuraLine.Delete.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.AurasWindow.AuraLine.Delete.getVal = function(self, tag)
  return self.Values[tag]
end
View.AurasWindow.AuraLine.Delete:setMargin(35, 0, 0, 0)
View.AurasWindow.AuraLine.Delete:setSize(75, 35)
View.AurasWindow.AuraLine.Delete:setAlignment(WIDGET_ALIGN_HIGH, WIDGET_ALIGN_LOW)
View.AurasWindow.AuraLine.Edit = { }
View.AurasWindow.AuraLine.Edit.widget = View.AurasWindow.AuraLine.widget:GetChildChecked("Edit", false)
View.AurasWindow.AuraLine.Edit.Values = { }
View.AurasWindow.AuraLine.Edit.reactionName = "edit"
View.AurasWindow.AuraLine.Edit.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.Edit.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.AurasWindow.AuraLine.Edit.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.Edit.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.AurasWindow.AuraLine.Edit.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.Edit.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.AurasWindow.AuraLine.Edit.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.Edit.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.AurasWindow.AuraLine.Edit.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.AurasWindow.AuraLine.Edit.getVal = function(self, tag)
  return self.Values[tag]
end
View.AurasWindow.AuraLine.Edit:setMargin(35, 0, 75, 0)
View.AurasWindow.AuraLine.Edit:setSize(75, 35)
View.AurasWindow.AuraLine.Edit:setAlignment(WIDGET_ALIGN_HIGH, WIDGET_ALIGN_LOW)
View.AurasWindow.AuraLine.NameView = { }
View.AurasWindow.AuraLine.NameView.widget = View.AurasWindow.AuraLine.widget:GetChildChecked("NameView", false)
View.AurasWindow.AuraLine.NameView.Values = { }
View.AurasWindow.AuraLine.NameView.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.NameView.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.AurasWindow.AuraLine.NameView.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.NameView.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.AurasWindow.AuraLine.NameView.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.NameView.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.AurasWindow.AuraLine.NameView.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.AuraLine.NameView.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.AurasWindow.AuraLine.NameView.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.AurasWindow.AuraLine.NameView.getVal = function(self, tag)
  return self.Values[tag]
end
View.AurasWindow.AuraLine.NameView.setFormat = function(self, format)
  self.widget:SetFormat(format)
end
View.AurasWindow.AuraLine.NameView:setMargin(35, 0, 150, 0)
View.AurasWindow.AuraLine.NameView:setSize(445, 35)
View.AurasWindow.AuraLine.NameView:setAlignment(WIDGET_ALIGN_BOTH, WIDGET_ALIGN_BOTH)
View.AurasWindow.DockPanel = { }
View.AurasWindow.DockPanel.widget = View.AurasWindow.widget:GetChildChecked("Content", false):GetChildChecked("DockPanel", false)

View.AurasWindow.DockPanel.ButtomButtons = { }
View.AurasWindow.DockPanel.ButtomButtons.widget = View.AurasWindow.DockPanel.widget:GetChildChecked("ButtomButtons", false)

View.AurasWindow.DockPanel.ButtomButtons.Add = { }
View.AurasWindow.DockPanel.ButtomButtons.Add.widget = View.AurasWindow.DockPanel.ButtomButtons.widget:GetChildChecked("Add", false)
View.AurasWindow.DockPanel.ButtomButtons.Add.Values = { }
View.AurasWindow.DockPanel.ButtomButtons.Add.reactionName = "add"
View.AurasWindow.DockPanel.ButtomButtons.Add.setPosition = function(self, x, y)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = x
  placement.posY = y
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.DockPanel.ButtomButtons.Add.getPosition = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { posX = placement.posX, posY = placement.posY }
end
View.AurasWindow.DockPanel.ButtomButtons.Add.setMargin = function(self, left, top, right, bottom)
  local placement = self.widget:GetPlacementPlain ()
  placement.posX = left
  placement.posY = top
  placement.highPosX = right
  placement.highPosY = bottom
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.DockPanel.ButtomButtons.Add.getMargin = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { left = placement.posX, top = placement.posY, right = placement.highPosX, bottom = placement.highPosY }
end
View.AurasWindow.DockPanel.ButtomButtons.Add.setSize = function(self, width, height)
  local placement = self.widget:GetPlacementPlain ()
  placement.sizeX = width
  placement.sizeY = height
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.DockPanel.ButtomButtons.Add.getSize = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { width = placement.sizeX, height = placement.sizeY }
end
View.AurasWindow.DockPanel.ButtomButtons.Add.setAlignment = function(self, horizontalAlignment, verticalAlignment)
  local placement = self.widget:GetPlacementPlain ()
  placement.alignX = horizontalAlignment
  placement.alignY = verticalAlignment
  self.widget:SetPlacementPlain(placement)
end
View.AurasWindow.DockPanel.ButtomButtons.Add.getAlignment = function(self)
  local placement = self.widget:GetPlacementPlain ()
  return { alignX = placement.alignX, alignY = placement.alignY }
end
View.AurasWindow.DockPanel.ButtomButtons.Add.setVal = function(self, tag, value)
  self.widget:SetVal(tag, value)
  self.Values[tag] = value
end
View.AurasWindow.DockPanel.ButtomButtons.Add.getVal = function(self, tag)
  return self.Values[tag]
end
View.AurasWindow.DockPanel.ButtomButtons.Add:setMargin(0, 0, 0, 0)
View.AurasWindow.DockPanel.ButtomButtons.Add:setSize(200, 25)
View.AurasWindow.DockPanel.ButtomButtons.Add:setAlignment(WIDGET_ALIGN_HIGH, WIDGET_ALIGN_LOW)
View.AurasWindow.DockPanel.ScrollableContainer = { }
View.AurasWindow.DockPanel.ScrollableContainer.widget = View.AurasWindow.DockPanel.widget:GetChildChecked("ScrollableContainer", false)
for k, v in View.AurasWindow.DockPanel.ScrollableContainer do
  if v then
    if v.widget then
      View.AurasWindow.DockPanel.ScrollableContainer.widget:PushBack(v.widget)
    end
  end
end
